﻿Option Strict Off
Option Explicit On

Friend Class frmPALIT
	Inherits System.Windows.Forms.Form

	Private Structure RGBHSV
		Dim R As Short
		Dim G As Short
		Dim B As Short
		Dim H As Short
		Dim S As Short
		Dim V As Short
		Dim N As Integer
	End Structure

	Dim CLIPCOL, RY2, RY1, RY0, RX0, RX1, RX2, RGBColor, MAXCOL As Integer
	Dim PALST(255) As Integer
	Dim PALRA(255) As Integer
	Dim CVET As RGBHSV
	Dim picPALIT() As PictureBox

	Private Sub cbHELP_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cbHELP.Click
		frmHELP.ShowDialog()
	End Sub

	Private Sub cbREJIM_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cbREJIM.Click
		ALLFALSE()
	End Sub

	Private Sub cbSBROS_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cbSBROS.Click
		ALLSBROS()
	End Sub

	Private Sub frmPALIT_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		Dim I, J As Integer
		RX0 = 8 : RY0 = 12
		RX1 = 45 : RY1 = 14 : RX2 = 90 : RY2 = 7
		MAXCOL = 256 * 256 * 256
		CLIPCOL = -1
		For I = 0 To 255
			Dim tb As PictureBox = New PictureBox
			ReDim Preserve picPALIT(I)
			tb.Name = "picPALIT" + I.ToString
			tb.Tag = I.ToString
			AddHandler tb.MouseDown, AddressOf picPALIT_MouseDown
			AddHandler tb.MouseMove, AddressOf picPALIT_MouseMove
			Controls.Add(tb)
			picPALIT(I) = tb
		Next I
		For J = 0 To 15 : PALST(0 + J) = QBColor(J) : Next J
		For J = 0 To 15 : PALST(16 + J) = (J * 16 + 15) * 65793 : Next J
		For J = 0 To 15 : PALST(32 + J) = (J * 16 + 15) * 1 : Next J
		For J = 0 To 15 : PALST(48 + J) = (J * 16 + 15) * 257 : Next J
		For J = 0 To 15 : PALST(64 + J) = (J * 16 + 15) * 256 : Next J
		For J = 0 To 15 : PALST(80 + J) = (J * 16 + 15) * 65792 : Next J
		For J = 0 To 15 : PALST(96 + J) = (J * 16 + 15) * 65536 : Next J
		For J = 0 To 15 : PALST(112 + J) = (J * 16 + 15) * 65537 : Next J
		For J = 0 To 31 : PALST(128 + J) = (J * 3 + 64) * 1 + (157 - J * 3) * 256 : Next J
		For J = 0 To 31 : PALST(160 + J) = (J * 3 + 64) * 1 + (157 - J * 3) * 65536 : Next J
		For J = 0 To 31 : PALST(192 + J) = (J * 3 + 64) * 256 + (157 - J * 3) * 65536 : Next J
		For J = 0 To 7 : PALST(224 + J) = (J * 12 + 171) * 1 + (J * 12 + 85) * 256 : Next J
		For J = 0 To 7 : PALST(232 + J) = (J * 12 + 171) * 1 + (J * 12 + 85) * 65536 : Next J
		For J = 0 To 7 : PALST(240 + J) = (J * 12 + 171) * 256 + (J * 12 + 85) * 65536 : Next J
		For J = 0 To 7 : PALST(248 + J) = (J * 24 + 87) * 65793 : Next J
		SETEKRAN()
		Me.Show()
	End Sub

	Private Sub frmPALIT_FormClosed(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
		MsgBox("PALITNET, версия 5" & Chr(10) & "Автор Э.Г.Гаузер, Баку, 10.12.18" & Chr(10) & "https://erichware.com" & Chr(10) & "Программа распространяется свободно." & Chr(10) & "Все подробности на сайте автора.", , "PALITNET")
		End
	End Sub

	Private Sub optFON_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles optFON.CheckedChanged
		If eventSender.Checked Then
			txtTEXTHEX.Enabled = False
			txtTEXTDEC.Enabled = False
			txtFONHEX.Enabled = True
			txtFONDEC.Enabled = True
			txtMATHEX.Enabled = False
			txtMATDEC.Enabled = False
			txtCVET.BackColor = System.Drawing.ColorTranslator.FromOle(Val(txtFONDEC.Text))
			VALTEXT()
		End If
	End Sub

	Private Sub optMAT_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles optMAT.CheckedChanged
		If eventSender.Checked Then
			txtTEXTHEX.Enabled = False
			txtTEXTDEC.Enabled = False
			txtFONHEX.Enabled = False
			txtFONDEC.Enabled = False
			txtMATHEX.Enabled = True
			txtMATDEC.Enabled = True
			VALTEXT()
		End If
	End Sub

	Private Sub optTEXT_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles optTEXT.CheckedChanged
		If eventSender.Checked Then
			txtTEXTHEX.Enabled = True
			txtTEXTDEC.Enabled = True
			txtFONHEX.Enabled = False
			txtFONDEC.Enabled = False
			txtMATHEX.Enabled = False
			txtMATDEC.Enabled = False
			txtCVET.ForeColor = System.Drawing.ColorTranslator.FromOle(Val(txtTEXTDEC.Text))
			VALTEXT()
		End If
	End Sub

	Private Sub picCVETA_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles picCVETA.Click
		If CLIPCOL >= 0 And optMAT.Checked Then
			picCVETA.BackColor = System.Drawing.ColorTranslator.FromOle(CLIPCOL)
			INVRGB(CLIPCOL, CVET.R, CVET.G, CVET.B)
			IZMENA(1)
			IZMENA(2)
		End If
	End Sub

	Private Sub picPALIT_MouseDown(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.MouseEventArgs)
		Dim Button As Short = eventArgs.Button \ &H100000
		Dim Shift As Short = System.Windows.Forms.Control.ModifierKeys \ &H10000
		Dim Index As Short
		Index = Val(CType(eventSender, PictureBox).Tag)
		If Button = 1 Then
			If CLIPCOL >= 0 And Index > 15 And Index < 32 Then
				picPALIT(Index).BackColor = System.Drawing.ColorTranslator.FromOle(CLIPCOL)
				PALRA(Index) = CLIPCOL
			End If
		ElseIf Button = 2 Then
			CLIPCOL = PALRA(Index)
		End If
	End Sub

	Private Sub picPALIT_MouseMove(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.MouseEventArgs)
		Dim Button As Short = eventArgs.Button \ &H100000
		Dim Shift As Short = System.Windows.Forms.Control.ModifierKeys \ &H10000
		Dim TMP As Integer
		Dim K, I, J, Index As Short
		Dim S As String
		Index = Val(CType(eventSender, PictureBox).Tag)
		TMP = PALRA(Index)
		INVRGB(TMP, I, J, K)
		S = "R=" & Mid(Str(I), 2) & " G=" & Mid(Str(J), 2) & " B=" & Mid(Str(K), 2)
		lblTEK.Text = S
	End Sub

	Private Sub sliHSV1_Scroll(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles sliHSV1.Scroll
		HSVMODE()
	End Sub

	Private Sub sliHSV2_Scroll(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles sliHSV2.Scroll
		HSVMODE()
	End Sub

	Private Sub sliHSV3_Scroll(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles sliHSV3.Scroll
		HSVMODE()
	End Sub

	Private Sub sliRGB1_Scroll(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles sliRGB1.Scroll
		RGBMODE()
	End Sub

	Private Sub sliRGB2_Scroll(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles sliRGB2.Scroll
		RGBMODE()
	End Sub

	Private Sub sliRGB3_Scroll(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles sliRGB3.Scroll
		RGBMODE()
	End Sub

	Private Sub txtFONDEC_KeyPress(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyPressEventArgs) Handles txtFONDEC.KeyPress
		Dim KeyAscii As Short = Asc(eventArgs.KeyChar)
		Dim TMP As Integer
		Dim S As String
		VALIDKEYD(KeyAscii)
		If KeyAscii = 13 Then
			S = txtFONDEC.Text : TMP = MAXCOL
			If S <> "" Then TMP = Val(S)
			If TMP >= 0 And TMP < MAXCOL Then
				txtFONHEX.Text = Hex(TMP)
				txtCVET.BackColor = System.Drawing.ColorTranslator.FromOle(TMP)
				PERERIS(TMP)
			Else
				txtFONDEC.Text = Mid(Str(Val("&h" & txtFONHEX.Text)), 2)
			End If
		End If
		eventArgs.KeyChar = Chr(KeyAscii)
		If KeyAscii = 0 Then
			eventArgs.Handled = True
		End If
	End Sub

	Private Sub txtFONHEX_KeyPress(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyPressEventArgs) Handles txtFONHEX.KeyPress
		Dim KeyAscii As Short = Asc(eventArgs.KeyChar)
		Dim TMP As Integer
		Dim S As String
		VALIDKEYH(KeyAscii)
		If KeyAscii = 13 Then
			S = txtFONHEX.Text : TMP = MAXCOL
			If S <> "" Then TMP = Val("&h" & S)
			If TMP >= 0 And TMP < MAXCOL Then
				txtFONDEC.Text = Mid(Str(TMP), 2)
				txtCVET.BackColor = System.Drawing.ColorTranslator.FromOle(TMP)
				PERERIS(TMP)
			Else
				txtFONHEX.Text = Hex(Val(txtFONDEC.Text))
			End If
		End If
		eventArgs.KeyChar = Chr(KeyAscii)
		If KeyAscii = 0 Then
			eventArgs.Handled = True
		End If
	End Sub

	Private Sub txtMATDEC_KeyPress(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyPressEventArgs) Handles txtMATDEC.KeyPress
		Dim KeyAscii As Short = Asc(eventArgs.KeyChar)
		Dim TMP As Integer
		Dim S As String
		VALIDKEYD(KeyAscii)
		If KeyAscii = 13 Then
			S = txtMATDEC.Text : TMP = MAXCOL
			If S <> "" Then TMP = Val(S)
			If TMP >= 0 And TMP < MAXCOL Then
				txtMATHEX.Text = Hex(TMP)
				PERERIS(TMP)
			Else
				txtMATDEC.Text = Mid(Str(Val("&h" & txtMATHEX.Text)), 2)
			End If
		End If
		eventArgs.KeyChar = Chr(KeyAscii)
		If KeyAscii = 0 Then
			eventArgs.Handled = True
		End If
	End Sub

	Private Sub txtMATHEX_KeyPress(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyPressEventArgs) Handles txtMATHEX.KeyPress
		Dim KeyAscii As Short = Asc(eventArgs.KeyChar)
		Dim TMP As Integer
		Dim S As String
		VALIDKEYH(KeyAscii)
		If KeyAscii = 13 Then
			S = txtMATHEX.Text : TMP = MAXCOL
			If S <> "" Then TMP = Val("&h" & S)
			If TMP >= 0 And TMP < MAXCOL Then
				txtMATDEC.Text = Mid(Str(TMP), 2)
				PERERIS(TMP)
			Else
				txtMATHEX.Text = Hex(Val(txtMATDEC.Text))
			End If
		End If
		eventArgs.KeyChar = Chr(KeyAscii)
		If KeyAscii = 0 Then
			eventArgs.Handled = True
		End If
	End Sub

	Private Sub txtTEXTDEC_KeyPress(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyPressEventArgs) Handles txtTEXTDEC.KeyPress
		Dim KeyAscii As Short = Asc(eventArgs.KeyChar)
		Dim TMP As Integer
		Dim S As String
		VALIDKEYD(KeyAscii)
		If KeyAscii = 13 Then
			S = txtTEXTDEC.Text : TMP = MAXCOL
			If S <> "" Then TMP = Val(S)
			If TMP >= 0 And TMP < MAXCOL Then
				txtTEXTHEX.Text = Hex(TMP)
				txtCVET.ForeColor = System.Drawing.ColorTranslator.FromOle(TMP)
				PERERIS(TMP)
			Else
				txtTEXTDEC.Text = Mid(Str(Val("&h" & txtTEXTHEX.Text)), 2)
			End If
		End If
		eventArgs.KeyChar = Chr(KeyAscii)
		If KeyAscii = 0 Then
			eventArgs.Handled = True
		End If
	End Sub

	Private Sub txtTEXTHEX_KeyPress(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyPressEventArgs) Handles txtTEXTHEX.KeyPress
		Dim KeyAscii As Short = Asc(eventArgs.KeyChar)
		Dim TMP As Integer
		Dim S As String
		VALIDKEYH(KeyAscii)
		If KeyAscii = 13 Then
			S = txtTEXTHEX.Text : TMP = MAXCOL
			If S <> "" Then TMP = Val("&h" & S)
			If TMP >= 0 And TMP < MAXCOL Then
				txtTEXTDEC.Text = Mid(Str(TMP), 2)
				txtCVET.ForeColor = System.Drawing.ColorTranslator.FromOle(TMP)
				PERERIS(TMP)
			Else
				txtTEXTHEX.Text = Hex(Val(txtTEXTDEC.Text))
			End If
		End If
		eventArgs.KeyChar = Chr(KeyAscii)
		If KeyAscii = 0 Then
			eventArgs.Handled = True
		End If
	End Sub

	Private Sub txtHSV1_KeyPress(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyPressEventArgs) Handles txtHSV1.KeyPress
		Dim KeyAscii As Short = Asc(eventArgs.KeyChar)
		Dim TMP As Integer
		Dim S As String
		If KeyAscii = 13 Then
			S = txtHSV1.Text : TMP = 999
			If S <> "" Then TMP = Val(S)
			If TMP >= 0 And TMP <= 359 Then
				sliHSV1.Value = TMP : HSVMODE()
			Else
				txtHSV1.Text = Mid(Str(sliHSV1.Value), 2)
			End If
		End If
		eventArgs.KeyChar = Chr(KeyAscii)
		If KeyAscii = 0 Then
			eventArgs.Handled = True
		End If
	End Sub

	Private Sub txtHSV2_KeyPress(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyPressEventArgs) Handles txtHSV2.KeyPress
		Dim KeyAscii As Short = Asc(eventArgs.KeyChar)
		Dim TMP As Integer
		Dim S As String
		If KeyAscii = 13 Then
			S = txtHSV2.Text : TMP = 999
			If S <> "" Then TMP = Val(S)
			If TMP >= 0 And TMP <= 100 Then
				sliHSV2.Value = TMP : HSVMODE()
			Else
				txtHSV2.Text = Mid(Str(sliHSV2.Value), 2)
			End If
		End If
		eventArgs.KeyChar = Chr(KeyAscii)
		If KeyAscii = 0 Then
			eventArgs.Handled = True
		End If
	End Sub

	Private Sub txtHSV3_KeyPress(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyPressEventArgs) Handles txtHSV3.KeyPress
		Dim KeyAscii As Short = Asc(eventArgs.KeyChar)
		Dim TMP As Integer
		Dim S As String
		If KeyAscii = 13 Then
			S = txtHSV3.Text : TMP = 999
			If S <> "" Then TMP = Val(S)
			If TMP >= 0 And TMP <= 100 Then
				sliHSV3.Value = TMP : HSVMODE()
			Else
				txtHSV3.Text = Mid(Str(sliHSV3.Value), 2)
			End If
		End If
		eventArgs.KeyChar = Chr(KeyAscii)
		If KeyAscii = 0 Then
			eventArgs.Handled = True
		End If
	End Sub

	Private Sub txtRGB1_KeyPress(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyPressEventArgs) Handles txtRGB1.KeyPress
		Dim KeyAscii As Short = Asc(eventArgs.KeyChar)
		Dim TMP As Integer
		Dim S As String
		If KeyAscii = 13 Then
			S = txtRGB1.Text : TMP = 256
			If S <> "" Then TMP = Val(S)
			If TMP > -1 And TMP < 256 Then
				sliRGB1.Value = TMP : RGBMODE()
			Else
				txtRGB1.Text = Mid(Str(sliRGB1.Value), 2)
			End If
		End If
		eventArgs.KeyChar = Chr(KeyAscii)
		If KeyAscii = 0 Then
			eventArgs.Handled = True
		End If
	End Sub

	Private Sub txtRGB2_KeyPress(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyPressEventArgs) Handles txtRGB2.KeyPress
		Dim KeyAscii As Short = Asc(eventArgs.KeyChar)
		Dim TMP As Integer
		Dim S As String
		If KeyAscii = 13 Then
			S = txtRGB2.Text : TMP = 256
			If S <> "" Then TMP = Val(S)
			If TMP > -1 And TMP < 256 Then
				sliRGB2.Value = TMP : RGBMODE()
			Else
				txtRGB2.Text = Mid(Str(sliRGB2.Value), 2)
			End If
		End If
		eventArgs.KeyChar = Chr(KeyAscii)
		If KeyAscii = 0 Then
			eventArgs.Handled = True
		End If
	End Sub

	Private Sub txtRGB3_KeyPress(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyPressEventArgs) Handles txtRGB3.KeyPress
		Dim KeyAscii As Short = Asc(eventArgs.KeyChar)
		Dim TMP As Integer
		Dim S As String
		If KeyAscii = 13 Then
			S = txtRGB3.Text : TMP = 256
			If S <> "" Then TMP = Val(S)
			If TMP > -1 And TMP < 256 Then
				sliRGB3.Value = TMP : RGBMODE()
			Else
				txtRGB3.Text = Mid(Str(sliRGB3.Value), 2)
			End If
		End If
		eventArgs.KeyChar = Chr(KeyAscii)
		If KeyAscii = 0 Then
			eventArgs.Handled = True
		End If
	End Sub

	Private Sub ALLFALSE()
		optTEXT.Checked = False
		optFON.Checked = False
		optMAT.Checked = False
		txtTEXTHEX.Enabled = False
		txtTEXTDEC.Enabled = False
		txtFONHEX.Enabled = False
		txtFONDEC.Enabled = False
		txtMATHEX.Enabled = False
		txtMATDEC.Enabled = False
	End Sub

	Private Sub ALLSBROS()
		Dim I As Integer
		For I = 0 To 255 : PALRA(I) = PALST(I) : Next I
		For I = 0 To 255 : picPALIT(I).BackColor = System.Drawing.ColorTranslator.FromOle(PALRA(I)) : Next I
		ALLFALSE()
		txtCVET.ForeColor = System.Drawing.ColorTranslator.FromOle(0)
		txtTEXTHEX.Text = "0" : txtTEXTDEC.Text = "0"
		txtCVET.BackColor = System.Drawing.ColorTranslator.FromOle(MAXCOL - 1)
		txtFONHEX.Text = "FFFFFF" : txtFONDEC.Text = "16777215"
		picCVETA.BackColor = System.Drawing.ColorTranslator.FromOle(0)
		txtMATHEX.Text = "0" : txtMATDEC.Text = "0"
		txtCVET.Text = "ТЕКСТ переднего ПЛАНА на выбранном ФОНЕ. TEKST perednego PLANA na vybrannom FONE. 9876543210 `~!@#$%^&*()_-=+|\[]{}:;<>/?ЁЁ№Ъъ"
		CVET.R = 0 : CVET.G = 0 : CVET.B = 0
		IZMENA(1)
		IZMENA(2)
	End Sub

	Private Sub INVRGB(ByRef COLL As Integer, ByRef RR As Short, ByRef GG As Short, ByRef BB As Short)
		RR = COLL And 255
		GG = (COLL \ 256) And 255
		BB = COLL \ 65536
	End Sub

	Private Sub HSVMODE()
		CVET.H = sliHSV1.Value
		CVET.S = sliHSV2.Value
		CVET.V = sliHSV3.Value
		IZMENA(2)
	End Sub

	Private Sub RGBMODE()
		CVET.R = sliRGB1.Value
		CVET.G = sliRGB2.Value
		CVET.B = sliRGB3.Value
		IZMENA(1)
	End Sub

	Private Sub HSVTORGB()
		Dim G, T, P, V, H, S, F, Q, R, B As Single
		S = CVET.S / 100.0!
		V = CVET.V / 100.0!
		If S = 0 Then
			R = V : G = V : B = V
		Else
			H = CVET.H / 60.0! : If H = 6 Then H = 0
			F = H - Int(H)
			P = V * (1 - S)
			Q = V * (1 - S * F)
			T = V * (1 - S * (1 - F))
			Select Case Int(H)
				Case 0 : R = V : G = T : B = P
				Case 1 : R = Q : G = V : B = P
				Case 2 : R = P : G = V : B = T
				Case 3 : R = P : G = Q : B = V
				Case 4 : R = T : G = P : B = V
				Case 5 : R = V : G = P : B = Q
				Case Else
			End Select
		End If
		CVET.R = Int(255.9999 * R)
		CVET.G = Int(255.9999 * G)
		CVET.B = Int(255.9999 * B)
	End Sub

	Private Sub RGBTOHSV()
		Dim V, H, G, R, B, S, U As Single
		R = CVET.R / 255.0!
		G = CVET.G / 255.0!
		B = CVET.B / 255.0!
		V = R
		If V < G Then V = G
		If V < B Then V = B
		U = R
		If U > G Then U = G
		If U > B Then U = B
		S = 0 : CVET.H = 0
		If V <> 0 Then S = (V - U) / V
		If S <> 0 Then
			If V = R Then H = (G - B) / (V - U)
			If V = G Then H = 2 + (B - R) / (V - U)
			If V = B Then H = 4 + (R - G) / (V - U)
			CVET.H = Int(H * 60)
			If CVET.H < 0 Then CVET.H = CVET.H + 360
		End If
		CVET.S = Int(S * 100)
		CVET.V = Int(V * 100)
	End Sub

	Private Sub PERERIS(ByRef TMP As Integer)
		INVRGB(TMP, CVET.R, CVET.G, CVET.B)
		IZMENA(1)
		IZMENA(2)
	End Sub

	Private Sub SETEKRAN()
		Dim I, J As Integer
		For I = 0 To 7
			For J = 0 To 15
				picPALIT(I * 16 + J).BorderStyle = 0
				picPALIT(I * 16 + J).Cursor = Cursors.Cross
				picPALIT(I * 16 + J).Visible = True
				picPALIT(I * 16 + J).Width = RX1
				picPALIT(I * 16 + J).Height = RY1
				picPALIT(I * 16 + J).Left = I * RX1 + RX0
				picPALIT(I * 16 + J).Top = J * RY1 + RY0
			Next J
		Next I
		For I = 0 To 3
			For J = 0 To 31
				picPALIT(I * 32 + J + 128).BorderStyle = 0
				picPALIT(I * 32 + J + 128).Cursor = Cursors.Cross
				picPALIT(I * 32 + J + 128).Visible = True
				picPALIT(I * 32 + J + 128).Width = RX2
				picPALIT(I * 32 + J + 128).Height = RY2
				picPALIT(I * 32 + J + 128).Left = I * RX2 + RX1 * 8 + RX0
				picPALIT(I * 32 + J + 128).Top = J * RY2 + RY0
			Next J
		Next I
		ALLSBROS()
	End Sub

	Private Sub IZMENA(ByRef REJIM As Short)
		Dim HGRN, I, HRED, HBLU As Integer
		Select Case REJIM
			Case 1
				RGBTOHSV()
				sliHSV1.Value = CVET.H
				sliHSV2.Value = CVET.S
				sliHSV3.Value = CVET.V
			Case 2
				HSVTORGB()
				sliRGB1.Value = CVET.R
				sliRGB2.Value = CVET.G
				sliRGB3.Value = CVET.B
		End Select
		txtRGB1.Text = Format(CVET.R, "##0")
		txtRGB2.Text = Format(CVET.G, "##0")
		txtRGB3.Text = Format(CVET.B, "##0")
		txtHSV1.Text = Format(CVET.H, "##0")
		txtHSV2.Text = Format(CVET.S, "##0")
		txtHSV3.Text = Format(CVET.V, "##0")
		HRED = CVET.R : HGRN = CVET.G : HBLU = CVET.B
		For I = 32 To 47 : PALRA(I) = PALST(I) + HGRN * 256 + HBLU * 65536 : Next I
		For I = 48 To 63 : PALRA(I) = PALST(I) + HBLU * 65536 : Next I
		For I = 64 To 79 : PALRA(I) = PALST(I) + HRED + HBLU * 65536 : Next I
		For I = 80 To 95 : PALRA(I) = PALST(I) + HRED : Next I
		For I = 96 To 111 : PALRA(I) = PALST(I) + HRED + HGRN * 256 : Next I
		For I = 112 To 127 : PALRA(I) = PALST(I) + HGRN * 256 : Next I
		For I = 128 To 159 : PALRA(I) = PALST(I) + HBLU * 65536 : Next I
		For I = 160 To 191 : PALRA(I) = PALST(I) + HGRN * 256 : Next I
		For I = 192 To 223 : PALRA(I) = PALST(I) + HRED : Next I
		For I = 224 To 231 : PALRA(I) = PALST(I) + HBLU * 65536 : Next I
		For I = 232 To 239 : PALRA(I) = PALST(I) + HGRN * 256 : Next I
		For I = 240 To 247 : PALRA(I) = PALST(I) + HRED : Next I
		VALTEXT()
	End Sub

	Private Sub VALIDKEYD(ByRef KLAV As Short)
		If KLAV = 13 Or KLAV = 8 Then Exit Sub
		If KLAV > 47 And KLAV < 58 Then Exit Sub
		KLAV = 0
	End Sub

	Private Sub VALIDKEYH(ByRef KLAV As Short)
		If KLAV = 13 Or KLAV = 8 Then Exit Sub
		If KLAV > 47 And KLAV < 58 Then Exit Sub
		If KLAV > 64 And KLAV < 71 Then Exit Sub
		If KLAV > 96 And KLAV < 103 Then KLAV = KLAV - 32 : Exit Sub
		KLAV = 0
	End Sub

	Private Sub VALTEXT()
		Dim I As Integer
		Dim S As String
		RGBColor = RGB(CVET.R, CVET.G, CVET.B)
		S = Mid(Str(RGBColor), 2)
		If optTEXT.Checked Then
			txtCVET.ForeColor = System.Drawing.ColorTranslator.FromOle(RGBColor)
			txtTEXTHEX.Text = Hex(RGBColor)
			txtTEXTDEC.Text = S
		ElseIf optFON.Checked Then
			txtCVET.BackColor = System.Drawing.ColorTranslator.FromOle(RGBColor)
			txtFONHEX.Text = Hex(RGBColor)
			txtFONDEC.Text = S
		Else
			picCVETA.BackColor = System.Drawing.ColorTranslator.FromOle(RGBColor)
			If optMAT.Checked Then
				txtMATHEX.Text = Hex(RGBColor)
				txtMATDEC.Text = S
				For I = 0 To 255 : picPALIT(I).BackColor = System.Drawing.ColorTranslator.FromOle(PALRA(I)) : Next I
			End If
		End If
	End Sub

End Class
